package com.weaver.seconddev.interfaces.workflow.action;

import javax.xml.namespace.QName;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import com.weaver.common.i18n.tool.util.I18nContextUtil;
import com.weaver.verupgrade.conn.CONN_TYPE;
import java.util.*;
import com.weaver.verupgrade.workflow.request.RequestManager;
import com.weaver.esb.api.rpc.EsbServerlessRpcRemoteInterface;
import com.weaver.common.base.entity.result.WeaResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import com.weaver.verupgrade.soa.workflow.request.RequestInfo;
import java.util.Map;
import java.util.HashMap;
import com.weaver.verupgrade.conn.RecordSet;
import com.weaver.verupgrade.conn.RecordSetDataSource;
import com.weaver.verupgrade.general.TimeUtil;
import com.weaver.verupgrade.general.Util;
import com.weaver.verupgrade.interfaces.workflow.action.Action;
import com.weaver.verupgrade.soa.workflow.request.Property;
import com.weaver.verupgrade.soa.workflow.request.Cell;
import com.weaver.verupgrade.soa.workflow.request.DetailTable;
import com.weaver.verupgrade.soa.workflow.request.Row;

@org.springframework.stereotype.Service("workflow_action_GangWeiXinZengAction")
public class GangWeiXinZengAction implements Action, EsbServerlessRpcRemoteInterface {

    // 对应E9的请求信息对象
    @Autowired
    private RequestInfo requestInfoTemp;

    private static final Logger logger_3bab3f4e = LoggerFactory.getLogger(GangWeiXinZengAction.class);

    private Log log = LogFactory.getLog(GangWeiXinZengAction.class.getName());

    public Log getLog() {
        return log;
    }

    public void setLog(Log log) {
        this.log = log;
    }

    public WeaResult<Map<String, Object>> execute(Map<String, Object> requestInfoMap) {
        Map<String, Object> weaverResultMap = new HashMap<>();
        Long requestIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("requestid", -1)));
        Long userIdTemp = Long.parseLong(String.valueOf(requestInfoMap.getOrDefault("userid", -1)));
        RequestInfo request = requestInfoTemp.getRequestInfo(requestIdTemp, userIdTemp);
        // RecordSetDataSource rsds = new RecordSetDataSource("eHR_test");
        // rsds.executeSql("select 员工GUID AS YGID from ht_psnaccount where 员工工号 ="+createrId);
        // rsds.next();
        // String  ApplyerID =  Util.null2String(rsds.getString("YGID"));
        // int departmentId = Util.getIntValue(rs2.getString("id"));
        // RecordSet rs3 = new RecordSet();
        // rs3.executeSql("select * from HrmJobTitles where id="+XQGW);
        // if (!rs3.next()){
        // PositionStatus = "1";
        // }
        try {
            log.info("do action on request:" + request.getRequestid());
            String requestid = request.getRequestid();
            String lastoperator = request.getLastoperator();
            String creater = request.getCreatorid();
            RecordSet rs = I18nContextUtil.getBean(RecordSet.class);
            RecordSet rs2 = I18nContextUtil.getBean(RecordSet.class);
            String workflowid = request.getWorkflowid();
            String maintable = "";
            String sql = "select b.tablename from wfp_base a,form b where a.formid = b.id and a.id = " + workflowid;
            String createsqlString = "select id  from employee as  hrmresource where lastname ='" + creater + "'";
            String poolname = CONN_TYPE.workflow.getType();
            // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
            rs2.executeSql(createsqlString, poolname);
            rs2.next();
            String createrId = rs2.getString("id");
            String poolname_xh = CONN_TYPE.workflow.getType();
            // RecordSetDataSource rsds = new RecordSetDataSource("eHR_test");
            // rsds.executeSql("select 员工GUID AS YGID from ht_psnaccount where 员工工号 ="+createrId);
            // rsds.next();
            // String  ApplyerID =  Util.null2String(rsds.getString("YGID"));
            // int departmentId = Util.getIntValue(rs2.getString("id"));
            /*        String creater = rs2.getString("departmentmark") + "_" + rs2.getString("lastname");
 TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源*/
            rs.executeSql(sql, poolname_xh);
            while (rs.next()) {
                maintable = rs.getString("tablename");
            }
            // 申请部门
            String SQBM = "";
            // 新增岗位名称
            String SQGWMC = "";
            // 申请岗位名称
            String SQGWMC2 = "";
            // 申请日期
            String SQRQ = "";
            // 需求原因
            String SQYY = "";
            // 是否新增岗位
            String PositionStatus = "";
            // 岗位序列GUID
            String PositionAttID = "";
            // 岗位类型GUID
            String PositionTypeID = "";
            String SQZWLX = "";
            String SQZW = "";
            String PositionID = "";
            String DeptID = "";
            // 获取表单主字段信息
            Property[] properties = request.getMainTableInfo().getProperty();
            for (int i = 0; i < properties.length; i++) {
                // 主表数据
                // 字段名
                String name = properties[i].getName().toUpperCase();
                // 值
                String value = Util.null2String(properties[i].getValue());
                if (name.equals("SQRQ")) {
                    SQRQ = value;
                    SQRQ = SQRQ.substring(0, 10);
                } else if (name.equals("SQYY")) {
                    SQYY = value;
                } else if (name.equals("SQBM")) {
                    SQBM = value;
                    String poolname_li = CONN_TYPE.workflow.getType();
                    // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                    rs.executeSql("select code from department as  HrmDepartment where id =" + SQBM, poolname_li);
                    rs.next();
                    DeptID = Util.null2String(rs.getString("departmentcode"));
                } else if (name.equals("SQGWMC")) {
                    SQGWMC = value;
                } else if (name.equals("SQGWMC2")) {
                    SQGWMC2 = value;
                } else if (name.equals("SQZWLX1")) {
                    // PositionAttID = value;
                    SQZWLX = value;
                } else if (name.equals("SQZW1")) {
                    // PositionTypeID = value;
                    SQZW = value;
                }
                log.info("main:" + requestid + "	" + name + "	" + value);
            }
            if (!SQGWMC2.equals("")) {
                String poolname_i3 = CONN_TYPE.workflow.getType();
                /*RecordSetDataSource rsds = new RecordSetDataSource("HR");
 TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源*/
                rs.executeSql("select code from position as  HrmJobTitles where id =" + SQGWMC2, poolname_i3);
                // rsds.execute("select 岗位GUID AS GWGUID from ht_jobcode where 岗位ID ='"+SQGWMC1+"'");
                // rsds.next();
                rs.next();
                PositionID = Util.null2String(rs.getString("jobtitlecode"));
                PositionStatus = "0";
                // RecordSet rs3 = new RecordSet();
                // String sql3 = "select a.JobActivitiescode,b.jobgroupscode from (select JobActivitiescode,jobgroupid from HrmJobActivities where " +
                // "id in (select  jobactivityid from HrmJobTitles where jobtitlecode='"+SQGWMC1+"' and jobdepartmentid ="+SQBM+"))a left join HrmJobGroups b on a.jobgroupid=b.id ";
                // rs3.executeSql(sql3);
                // rs3.next();
                // PositionAttID = rs3.getString("JobActivitiescode");
                // PositionTypeID = rs3.getString("jobgroupscode");
            }
            if (!SQZWLX.equals("")) {
                RecordSet rs3 = I18nContextUtil.getBean(RecordSet.class);
                String poolname_1r = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs3.executeSql("select jobgroupscode from hrm_jobtype_set as  HrmJobGroups where id=" + SQZWLX, poolname_1r);
                rs3.next();
                PositionAttID = Util.null2String(rs3.getString("jobgroupscode"));
            }
            if (!SQZW.equals("")) {
                RecordSet rs4 = I18nContextUtil.getBean(RecordSet.class);
                String poolname_cg = CONN_TYPE.workflow.getType();
                // TODO E10执行sql方法第二参数必须指定源，默认使用流程源，单体客户无需修改，微服务/组合客户需根据查询表所属服务切换源，或使用外部数据源
                rs4.executeSql("select JobActivitiescode from hrm_jobset as  HrmJobActivities where id=" + SQZW, poolname_cg);
                rs4.next();
                PositionTypeID = Util.null2String(rs4.getString("JobActivitiescode"));
            }
            if (!SQGWMC.equals("")) {
                PositionStatus = "1";
            }
            // RecordSet rs3 = new RecordSet();
            // rs3.executeSql("select * from HrmJobTitles where id="+XQGW);
            // if (!rs3.next()){
            // PositionStatus = "1";
            // }
            try {
                // ApplyPositionFormWS(XQBM,XQGW,SQRQ,Integer.parseInt(XQRS),XWBDRQ,ZBFS2,XQYY1);
                // JobCodeToDeptFormWS(XQBM,XQGW,createrId,SQRQ);
                String endPoint = "http://10.6.2.12/hengtongws/HengtongWebService.asmx";
                String soapaction = "http://tempuri.org/";
                Service service = new Service();
                Call call1 = (Call) service.createCall();
                call1.setTargetEndpointAddress(new java.net.URL(endPoint));
                call1.setOperationName(new QName(soapaction, "JobCodeToDeptFormWS"));
                call1.addParameter(new QName(soapaction, "DeptID"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "PositionAttID"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "PositionTypeID"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "PositionID"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "PositionStatus"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "PositionName"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "ApplyerID"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.addParameter(new QName(soapaction, "ApplyDate"), org.apache.axis.encoding.XMLType.XSD_STRING, javax.xml.rpc.ParameterMode.INOUT);
                call1.setReturnType(new QName(soapaction, "JobCodeToDeptFormWS"), String.class);
                call1.setUseSOAPAction(true);
                call1.setSOAPActionURI(soapaction + "JobCodeToDeptFormWS");
                log.info("DeptID:-----  " + DeptID + "PositionAttID: -----  " + PositionAttID + "PositionTypeID:  ----" + PositionTypeID + "PositionID :  ----" + PositionID + "PositionStatus------  " + PositionStatus + "SQGWMC:" + SQGWMC + "createrId:----" + createrId + "SQRQ:  ----" + SQRQ);
                String str = (String) call1.invoke(new Object[] { DeptID, PositionAttID, PositionTypeID, PositionID, PositionStatus, SQGWMC, createrId, SQRQ });
                System.out.println(str);
                log.info("str:" + str);
                if (!str.equals("SUCCESS")) {
                    request.getRequestManager().setMessageid("100004");
                    request.getRequestManager().setMessagecontent(str);
                }
            } catch (Exception e) {
                System.err.println(e.toString());
            }
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", Action.SUCCESS, request.getRequestManager()));
        } catch (Exception e) {
            e.printStackTrace();
            logger_3bab3f4e.error("GangWeiXinZengAction e: {}", e.getMessage());
            return WeaResult.success(getResultMapForAction(weaverResultMap, "result", WeaResult.fail(500, "执行异常", getResultMapForAction(weaverResultMap, "result", e.getMessage(), request.getRequestManager())), request.getRequestManager()));
        }
    }

    Map<String, Object> getResultMapForAction(Map<String, Object> map, String key, Object value, RequestManager requestManager) {
        if (key != null && !key.isEmpty()) {
            map.put(key, value);
        }
        String msgContent = requestManager.getMessagecontent();
        if (msgContent != null && !msgContent.isEmpty()) {
            map.put("msgContent", msgContent);
        }
        String msgId = requestManager.getMessageid();
        if (msgId != null && !msgId.isEmpty()) {
            map.put("msgId", msgId);
        }
        return map;
    }
}
